package cn.com.infosec.jce.provider;

import cn.com.infosec.crypto.params.AsymmetricKeyParameter;
import cn.com.infosec.crypto.params.GOST3410Parameters;
import cn.com.infosec.crypto.params.GOST3410PrivateKeyParameters;
import cn.com.infosec.crypto.params.GOST3410PublicKeyParameters;
import cn.com.infosec.jce.interfaces.GOST3410PrivateKey;
import cn.com.infosec.jce.interfaces.GOST3410PublicKey;
import cn.com.infosec.jce.spec.GOST3410PublicKeyParameterSetSpec;
import java.math.BigInteger;
import java.security.InvalidKeyException;
import java.security.PrivateKey;
import java.security.PublicKey;

public class GOST3410Util {
   public static AsymmetricKeyParameter generatePublicKeyParameter(PublicKey key) {
      if (key instanceof GOST3410PublicKey) {
         GOST3410PublicKey key1;
         GOST3410PublicKeyParameterSetSpec var1 = (key1 = (GOST3410PublicKey)key).getParameters().getPublicKeyParameters();
         BigInteger var10002 = key1.getY();
         GOST3410PublicKeyParameterSetSpec var10005 = var1;
         BigInteger key2 = var1.getP();
         BigInteger var5 = var1.getQ();
         BigInteger var2 = var10005.getA();
         return new GOST3410PublicKeyParameters(var10002, new GOST3410Parameters(key2, var5, var2));
      } else {
         throw new InvalidKeyException("can't identify GOST3410 public key: " + key.getClass().getName());
      }
   }

   public static AsymmetricKeyParameter generatePrivateKeyParameter(PrivateKey key) {
      if (key instanceof GOST3410PrivateKey) {
         GOST3410PrivateKey key1;
         GOST3410PublicKeyParameterSetSpec var1 = (key1 = (GOST3410PrivateKey)key).getParameters().getPublicKeyParameters();
         BigInteger var10002 = key1.getX();
         GOST3410PublicKeyParameterSetSpec var10005 = var1;
         BigInteger key2 = var1.getP();
         BigInteger var5 = var1.getQ();
         BigInteger var2 = var10005.getA();
         return new GOST3410PrivateKeyParameters(var10002, new GOST3410Parameters(key2, var5, var2));
      } else {
         throw new InvalidKeyException("can't identify GOST3410 private key.");
      }
   }
}
